#include <SoftwareSerial.h>

// Enable SoftwareSerial
// Read more about SoftwareSerial and ATtiny's at https://www.hackster.io/porrey/easy-serial-on-the-attiny-2676e6
#define SERIAL_TX 1
#define SERIAL_RX 3
SoftwareSerial Serial(SERIAL_RX, SERIAL_TX);

// Button and LED related defines and variables
#define LED 2
#define MOTOR 0
#define UP 6
#define DOWN 9
#define LEFT 8
#define RIGHT 10
#define CENTER 7
#define SEPARATOR 32

bool b_up = false; 
bool b_down = false;
bool b_left = false;
bool b_right = false;
bool b_center = false;

unsigned long motorOnMillis = 50;
unsigned long motorLastMillis = 0;

void setup() {
  pinMode(LED, OUTPUT);
  pinMode(MOTOR, OUTPUT);
  pinMode(UP, INPUT);
  pinMode(DOWN, INPUT);
  pinMode(LEFT, INPUT);
  pinMode(RIGHT, INPUT);
  pinMode(CENTER, INPUT);

  motorLastMillis = millis();
  
  Serial.begin(9600);
}

void loop() {
  unsigned long now = millis();

  
  bool left = !digitalRead(LEFT);
  bool right = !digitalRead(RIGHT);
  bool up = !digitalRead(UP);
  bool down = !digitalRead(DOWN);
  bool center = !digitalRead(CENTER);

  if(left){
    digitalWrite(LED, HIGH);
    motorLastMillis = now;
    if(!b_left){
      sendButtonState(LEFT, true);
      b_left = true;
    }
  }else{
    digitalWrite(LED, LOW);
    if(b_left){
      sendButtonState(LEFT, false);
      b_left = false;
    }
  }

  if(right){
    digitalWrite(LED, HIGH);
    motorLastMillis = now;
    if(!b_right){
      sendButtonState(RIGHT, true);
      b_right = true;
    }
  }else{
    digitalWrite(LED, LOW);
    if(b_right){
      sendButtonState(RIGHT, false);
      b_right = false;
    }
  }

  if(up){
    digitalWrite(LED, HIGH);
    motorLastMillis = now;
    if(!b_up){
      sendButtonState(UP, true);
      b_up = true;
    }
  }else{
    digitalWrite(LED, LOW);
    if(b_up){
      sendButtonState(UP, false);
      b_up = false;
    }
  }

  if(down){
    digitalWrite(LED, HIGH);
    motorLastMillis = now;
    if(!b_down){
      sendButtonState(DOWN, true);
      b_down = true;
    }
  }else{
    digitalWrite(LED, LOW);
    if(b_down){
      sendButtonState(DOWN, false);
      b_down = false;
    }
  }

  if(center){
    digitalWrite(LED, HIGH);
    motorLastMillis = now;
    if(!b_center){
      sendButtonState(CENTER, true);
      b_center = true;
    }
  }else{
    digitalWrite(LED, LOW);
    if(b_center){
      sendButtonState(CENTER, false);
      b_center = false;
    }
  }

  if(now - motorLastMillis < motorOnMillis){
    digitalWrite(MOTOR, HIGH);
  }else{
    digitalWrite(MOTOR, LOW);
  }
}

int sendButtonState(int button, int pressed){
  Serial.write(button);
  Serial.write(pressed);
  Serial.write(SEPARATOR);
}


